<?php
/*************************************************************************************/
/*                                                                                   */
/*      Thelia	                                                            		 */
/*                                                                                   */
/*      Copyright (c) Octolys Development		                                     */
/*		email : thelia@octolys.fr		        	                             	 */
/*      web : http://www.octolys.fr						   							 */
/*                                                                                   */
/*      This program is free software; you can redistribute it and/or modify         */
/*      it under the terms of the GNU General Public License as published by         */
/*      the Free Software Foundation; either version 2 of the License, or            */
/*      (at your option) any later version.                                          */
/*                                                                                   */
/*      This program is distributed in the hope that it will be useful,              */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of               */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                */
/*      GNU General Public License for more details.                                 */
/*                                                                                   */
/*      You should have received a copy of the GNU General Public License            */
/*      along with this program; if not, write to the Free Software                  */
/*      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA    */
/*                                                                                   */
/*************************************************************************************/
?>
<?php
	include_once(realpath(dirname(__FILE__)) . "/../../../classes/PluginsClassiques.class.php");
	include_once(realpath(dirname(__FILE__)) . "/classes/Devicedetect.class.php");

	class Ef_template extends PluginsClassiques{
		
		var $id;
		var $libelle;
		var $adresse;
		var $actifpc;
		var $actiftablette;
		var $actifmobile;
		var $sousdomaine;

		const TABLE="_ef_template";
		var $table=self::TABLE;

		var $bddvars = array("id", "libelle", "adresse", "actifpc", "actiftablette", "actifmobile","sousdomaine");

		function __construct($id = 0){
			parent::__construct();

			if($id > 0)
 			  $this->charger_id($id);
		}
		function charger_id($id){
			return $this->getVars("select * from $this->table where id=\"$id\"");
		}
		function charger_nom($libelle){
			return $this->getVars("select * from $this->table where libelle=\"$libelle\"");
		}
		
		function init()
		{		
			$cnx = new Cnx();
			/*
			Table contenant les templates
			*/
			$query = 'CREATE TABLE IF NOT EXISTS `_ef_template` (
				`id` int(11) NOT NULL AUTO_INCREMENT,
				`libelle` text NOT NULL,
				`adresse` text NOT NULL,
				`actifpc` int(11) NOT NULL,
				`actiftablette` int(11) NOT NULL,
				`actifmobile` int(11) NOT NULL,
				`sousdomaine` text NOT NULL,
				PRIMARY KEY (`id`)
			)';
			
			$resul = mysql_query($query,$cnx->link);
			
			//Ajout du template par defaut de thelia
			
			$query = 'INSERT INTO _ef_template VALUES ("","template d\'origine", "template/", "1","1","1","")';
			
			$resul = mysql_query($query,$cnx->link);
			
		}
		
		function destroy(){
			$cnx = new Cnx();
			/*
			Table contenant les templates
			*/
			$query = 'DROP TABLE _ef_template';
			
			$resul = mysql_query($query,$cnx->link);
		}
		
		
		function predemarrage(){

			$deviceDetect = new Devicedetect();

			/*$isOpera
			$isWindows
			$isWindowsphone
			$isGeneric*/
	
			//test des sous domaines
			
			if(!isset($_SESSION['thelia_Template']) || empty($_SESSION['thelia_Template'])){
			
				$query = 'SELECT * FROM '.$this->table.' WHERE sousdomaine LIKE("%'.$_SERVER['SERVER_NAME'].'%")';
				$resul = mysql_query($query);
				//Ne prendra que le premier dommaine existant
				if($row = mysql_fetch_object($resul)){
					$this->getVars("select * from $this->table where id=".$row->id." limit 0,1");
					$_SESSION['thelia_Template'] = serialize($this);
				}
				else{
					//test des devices
			
					//tablette
					if($deviceDetect->isAndroidtablet()) {
						$this->charger_actifTablette();
					}
					elseif($deviceDetect->isBlackberrytablet()) {
						$this->charger_actifTablette();
					}
					elseif($deviceDetect->isIpad()) {
						$this->charger_actifTablette();
					}
					//mobile
					elseif($deviceDetect->isAndroid()){
						$this->charger_actifMobile();
					}
					elseif($deviceDetect->isIphone()){
						$this->charger_actifMobile();
					}
					elseif($deviceDetect->isBlackberry()){
						$this->charger_actifMobile();
					}
					elseif($deviceDetect->isWindowsphone()){
						$this->charger_actifMobile();
					}
					elseif($deviceDetect->isPalm()){
						$this->charger_actifMobile();
					}
					elseif($deviceDetect->isMobile()){
						$this->charger_actifMobile();
					}
					//autre
					else{
						$this->charger_actifpc();
					}
				}
			}
			else{
				$this->id = unserialize($_SESSION['thelia_Template'])->id;
				$this->libelle = unserialize($_SESSION['thelia_Template'])->libelle;
				$this->adresse = unserialize($_SESSION['thelia_Template'])->adresse;
				$this->actifpc = unserialize($_SESSION['thelia_Template'])->actifpc;
				$this->actiftablette = unserialize($_SESSION['thelia_Template'])->actiftablette;
				$this->actifmobile = unserialize($_SESSION['thelia_Template'])->actifmobile;
				$this->sousdomaine = unserialize($_SESSION['thelia_Template'])->sousdomaine;
			}
			
			global $reptpl;
			$reptpl = $this->adresse;
			
		}
		
		function charger_actifPc(){
			$this->getVars("select * from $this->table where actifpc=1 limit 0,1");
			$_SESSION['thelia_Template'] = serialize($this);
			return true;
		}
		function charger_actifTablette(){
			$this->getVars("select * from $this->table where actiftablette=1 limit 0,1");
			$_SESSION['thelia_Template'] = serialize($this);
			return true;
		}
		function charger_actifMobile(){
			$this->getVars("select * from $this->table where actifmobile=1 limit 0,1");
			$_SESSION['thelia_Template'] = serialize($this);
			return true;
		}
		
		
		
		/*Fonctions pour le changement de template*/
		function switchTemplatePc($id){
			$query = 'update '.$this->table.' set actifpc=0';
			mysql_query($query);
			$query = 'update '.$this->table.' set actifpc=1 where id='.$id;
			mysql_query($query);
		}
		function switchTemplateTablette($id){
			$query = 'update '.$this->table.' set actiftablette=0';
			mysql_query($query);
			$query = 'update '.$this->table.' set actiftablette=1 where id='.$id;
			mysql_query($query);
		}
		function switchTemplateMobile($id){
			$query = 'update '.$this->table.' set actifmobile=0';
			mysql_query($query);
			$query = 'update '.$this->table.' set actifmobile=1 where id='.$id;
			mysql_query($query);
		}
		
		//surcharge de la méthode add pour eviter d'ajouter des templates de méme nom
		function add(){
			if($this->libelle!=''){
				$tmptemplate = new Ef_template();
				$tmptemplate->charger_nom($this->libelle);
				if($tmptemplate->id=='' || $tmptemplate->id=='0')
					parent::add();	
			}
		}
		
		//surcharge de la methode delete pour effacer les fichiers avant de supprimer les entrées en base
		// pas de suppression de fichiers pour l'instant
		function delete(){
			//if($this->adresse!='')
			//	$this->rmTemplate('../'.$this->adresse);
			parent::delete();
		}
		/*Fonction recursive pour effacer un template*/
		function rmTemplate($dir) { 
			if (is_dir($dir)) { 
				$objects = scandir($dir); 
				foreach ($objects as $object) { 
					if ($object != "." && $object != "..") { 
						if (filetype($dir."/".$object) == "dir") 
							$this->rmTemplate($dir."/".$object); 
						else unlink($dir."/".$object); 
					} 
				} 
				reset($objects); 
				rmdir($dir); 
			} 
		} 

	}


?>
